﻿Public Class AssetPicker

    Public Project As Project
    Private CodeChangesItem As Boolean

    Private _assetType As AssetType
    Public Property AssetType() As AssetType
        Get
            Return _assetType
        End Get
        Set(ByVal value As AssetType)
            _assetType = value
        End Set
    End Property

    Private _allowNone As Boolean
    Public Property AllowNone() As Boolean
        Get
            Return _allowNone
        End Get
        Set(ByVal value As Boolean)
            _allowNone = value
        End Set
    End Property

    Public Property SelectedAsset As Asset
        Get
            If Project Is Nothing Then
                Return Nothing
            End If
            If MainComboBox.SelectedItem Is Nothing Then
                Return Nothing
            Else
                Return Project.GetAsset(GetItemID(MainComboBox.SelectedItem))
            End If
        End Get
        Set(value As Asset)
            If value Is Nothing Then
                SetNone()
                Return
            End If
            For i = 0 To MainComboBox.Items.Count - 1
                If GetItemID(MainComboBox.Items(i)) = value.ID Then
                    SetIndex(i)
                    Return
                End If
            Next
            If GetItem(0) = "None" Then
                SetNone()
            End If
        End Set
    End Property

    Private Sub SetNone()
        If GetItem(0) = "None" Then
            SetIndex(0)
        Else
            CodeChangesItem = True
            MainComboBox.SelectedItem = Nothing
            CodeChangesItem = False
        End If
    End Sub

    Private Sub SetIndex(i As Integer)
        If i < 0 Or i >= MainComboBox.Items.Count Then
            Return
        End If
        CodeChangesItem = True
        MainComboBox.SelectedIndex = i
        CodeChangesItem = False
    End Sub

    Private Function GetItem(i As Integer) As String
        If i < 0 Or i >= MainComboBox.Items.Count Then
            Return ""
        End If
        Return MainComboBox.Items(i)
    End Function

    Private Shared Function GetItemID(item As String) As Integer
        Dim colonPos = item.IndexOf(":")
        If colonPos = -1 Then
            Return -1
        End If

        Return item.Substring(0, colonPos)
    End Function

    Sub LoadData()
        CodeChangesItem = True
        MainComboBox.BeginUpdate()
        MainComboBox.Items.Clear()
        If AllowNone Then
            MainComboBox.Items.Add("None")
        End If
        For Each a In Project.Assets
            If a.Type = AssetType Then
                MainComboBox.Items.Add(a.ID & ": " & a.Name)
            End If
        Next
        MainComboBox.EndUpdate()
        CodeChangesItem = False
    End Sub

    Private Sub AssetPicker_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        MainComboBox.ForeColor = ForeColor
    End Sub

    Public Event UserPickedAsset(sender As Object, e As EventArgs)

    Private Sub MainComboBox_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles MainComboBox.SelectedIndexChanged
        If Not CodeChangesItem Then
            RaiseEvent UserPickedAsset(Me, e)
        End If
    End Sub
End Class
